c----------------------------------------------------------------------
      subroutine coulfn(lmax,eta,zz,drho,rhomax,sigma0,f,fp,g,gp)
c     coulomb wave functions
c     modified by m.ichimura 1989.5.26
c----------------------------------------------------------------------
      include 'dimn.fh'
c
      dimension f(*),fp(*),g(*),gp(*)
      dimension fbart(3),tg(3),fbar(nldm),gt(2,2)
      double precision corec1,fbart,fl,flsq,t1,fl1,t2,fbarc1,fbarc2,
     1corec2,rhomxd,tg,fac1,fac2,fac3,fac4
      data eps1,eps2,eps3,eps4/1.0,10.0,20.0,30.0/
c
      eta2=eta*eta
      eta1=eta+eta
      rhomx=rhomax
      rhomxd=rhomx
      lmax1=lmax+1
      eeps1=eps1*0.000001
      eeps2=eps2*0.000001
      eeps3=eps3*0.000001
      corec1=1.0d-10
      sq=sqrt (1.0+eta2)
      if(zz.le.1.0) then
        eta=0.0
        eta2=0.0
        sq=1.0
        go to 155
      end if
      m=1
      rhomxg=rhomx+drho*eps4
      ninc=0
   50 sl1=1.0
      tl1=0.0
      sc1=0.0
      tc1=1.0-eta/rhomxg
      sl=sl1
      tl=tl1
      sc=sc1
      tc=tc1
      if(abs (eta).gt.eeps1) then
        do 60 n=1,25
          t1=n
          t2=2.0*t1-1.0
          t3=t1*(t1-1.0)
          denom=2.0*rhomxg*t1
          c1=(eta*t2)/denom
          c2=(eta2-t3)/denom
          sl2=c1*sl1-c2*tl1
          tl2=c1*tl1+c2*sl1
          sc2=c1*sc1-c2*tc1-sl2/rhomxg
          tc2=c1*tc1+c2*sc1-tl2/rhomxg
          sl=sl+sl2
          tl=tl+tl2
          sc=sc+sc2
          tc=tc+tc2
          sl1=sl2
          tl1=tl2
          sc1=sc2
          tc1=tc2
   60   continue
      end if
      if(m.le.1) then
        if(abs (sl*tc-sc*tl-1.0).ge.eeps1) then
          ninc=ninc+1
          if(ninc.lt.50) then
            rhomxg=rhomxg+drho*eps4
            go to 50
          end if
          kcheck=5
          write(6,6500) kcheck
 6500     format(27h0 coulfn subroutine kcheck=,i2)
          return
        end if
      end if
      arg=sigma0+rhomxg-eta*alog(2.0*rhomxg)
      sine=sin (arg)
      cosi=cos (arg)
      gt(1,m)=sl*cosi-tl*sine
      gdt=sc*cosi-tc*sine
      t1=sq
      gt(2,m)=((eta+1.0/rhomxg)*gt(1,m)-gdt)/t1
      if(m.le.1) then
        m=m+1
        rhomxg=rhomxg+drho
        go to 50
      end if
c     inward solution of differential equation
      rhomxg=rhomxg-drho
      if(abs (rhomxg-rhomx).le.0.0001) then
        g(1)=gt(1,1)
        g(2)=gt(2,1)
        tg(3)=g(1)
        tg(2)=g(2)
        go to 160
      end if
      drsq=drho*drho
      drsq56=0.83333333d0*drsq
      drsq12=0.1*drsq56
      nmax1=(rhomxg-rhomx)/drho+0.1
      do 150 l=1,2
        rhotm=rhomxg
        fl=l*(l-1)
        psi1=gt(l,2)
        psi2=gt(l,1)
        r1=rhotm+drho
        r2=rhotm
        r3=rhotm-drho
        do 145 n=1,nmax1
          denom=1.0-drsq12*(fl/(r3*r3)+eta1/r3-1.0)
          fac1=(1.0-drsq12*(fl/(r1*r1)+eta1/r1-1.0))/denom
          fac2=(2.0+drsq56*(fl/(r2*r2)+eta1/r2-1.0))/denom
          psi3=fac2*psi2-fac1*psi1
          psi1=psi2
          psi2=psi3
          r1=r2
          r2=r3
          r3=r3-drho
  145   continue
        if(l.eq.1) tg(3)=psi3
        if(l.eq.2) tg(2)=psi3
        g(l)=psi3
  150 continue
      go to 160
  155 tg(3)=dcos(rhomxd)
      g(1)=tg(3)
      tg(2)=tg(3)/rhomxd+dsin(rhomxd)
      g(2)=tg(2)
  160 t1=sq
      do 170 l=1,lmax
      fl=l
      fl1=fl+1.0
      t2=dsqrt(eta2+fl1*fl1)
      fac1=1.0/(fl*t2)
      fac2=(fl+fl1)*eta
      fac3=(fl+fl1)*fl*fl1
      fac4=fl1*t1
      tg(1)=fac1*((fac2+(fac3/rhomxd))*tg(2)-fac4*tg(3))
      g(l+2)=tg(1)
      tg(3)=tg(2)
      tg(2)=tg(1)
      t1=t2
  170 continue
c     calculation of f
  210 idec=max(31.01,rhomx)
      idecme=idec
  220 l=lmax+idec
      fbart(2)=1.0d-25
      fbart(3)=0.0d0
      imax=l-1
      fl=l
      flsq=fl*fl
      t1=dsqrt(flsq+eta2)
      do 300 i=1,imax
      l=imax+1-i
      fl=l
      fl1=fl+1.0d0
      flsq=fl*fl
      t2=dsqrt(flsq+eta2)
      fbart(1)=((fl+fl1)*(eta+fl*fl1/rhomx)*fbart(2)-fl*t1*fbart(3))
     1/(fl1*t2)
      fbarc1=fbart(1)
      fbarc2=dabs(fbarc1)
      if(((l.eq.lmax1).and.(fbarc2.ge.corec1))
     1  .or.((l.gt.lmax1).and.(fbarc2.ge.1.0e16))) then
        corec2=corec1/fbarc1
        fbart(1)=corec2*fbart(1)
        fbart(2)=corec2*fbart(2)
      end if
      fbart(3)=fbart(2)
      fbart(2)=fbart(1)
      if(l.le.lmax1) then
        fbar(l)=fbart(1)
      end if
      t1=t2
  300 continue
      alpha=1.0/((fbar(1)*g(2)-fbar(2)*g(1))*sq)
  320 do 330 l=1,lmax1
  330 fbar(l)=alpha*fbar(l)
      if(idec-idecme) 335,340,335
  335 if(fbar(1)) 338,336,338
  336 if(abs(f(1))-0.000001) 360,360,340
  338 if(abs(f(1)/fbar(1)-1.0)-eeps2) 360,360,340
  340   do 345 l=1,lmax1
  345   f(l)=fbar(l)
        idec=idec+9
        if(idec+lmax1-idecme.le.200) go to 220
        kcheck=7
        write(6,6300) kcheck
 6300   format(27h0 coulfn subroutine kcheck=,i2)
        return
c     end if
  360 do 370 l=1,lmax1
      l1=l
      if(fbar(l).eq.0) then
        if(abs (f(l)).le.0.00001) go to 370
        kcheck=8
        write(6,6400) kcheck
 6400   format(27h0 coulfn subroutine kcheck=,i2)
        return
      end if
      t1=abs (f(l)/fbar(l)-1.0)
      if(t1.gt.eeps2) then
        l1=0
        go to 372
      end if
  370 continue
  372 if(l1.eq.0) go to 340
      t1=sq
      do 390 l=1,lmax
      fl=l
      fl1=fl+1.0
      t2=dsqrt(fl1*fl1+eta2)
      ts=fl/t1
      wronsk=abs (f(l)*g(l+1)-f(l+1)*g(l)-ts)
      if(wronsk.gt.eeps3) then
        kcheck=9
        write(6,6200) kcheck
 6200   format(27h0 coulfn subroutine kcheck=,i2)
        return
      end if
      t1=t2
  390 continue
      do 400 l=1,lmax
        fl=l
        flsq=fl*fl
        fac1=eta/fl+fl/rhomx
        fac2=dsqrt(eta2+flsq)/fl
        fp(l)=fac1*f(l)-fac2*f(l+1)
        gp(l)=fac1*g(l)-fac2*g(l+1)
  400 continue
      return
      end
