c----------------------------------------------------------------------
      subroutine ovlap(itrj,nw,samp,wgt,ampm,NDMT,KTAMP,nsrmax,dsr,
     &                 pspn1,Atg,fratio,sval,tmasx)
c----------------------------------------------------------------------
c  Calculation of Tr[TT^+]
c      corresponding to Eq.(4.11) of PRC(2001)044609
c    Input
c      itrj: index od transferred J (Jtr+1)                           
c      nw  :                                                          
c      samp: distorted wave vertex amplitudes calculated in ampsub    
c      wgt : weight function of sympson integral calculated in ampla  
c      NDMT: (NN),(ND),(DD) and full specification                    
c      KTAMP: specify the included types of the NN amplitudes         
c      nsrmax:                                                        
c      dsr                                                            
c      Atg:                                                           base
C   sval  : s-value of the scattering system in MeV^2
C   tmasx(i) : i=1;target mass, i=2; residual nucleus mass in MeV
c      rffr(nra,nrb,ip,kls,itrj,NW,NDM)                               form
c    Output
c       ampm(msf1,msi1,msf2,msi2,ip,NDM):                             
c         Tr[TT^+] for fixed theta,Jtr,Mtr
c        msf1,msf2 : spin z-comp. of ejectile
c        msi1,msi2 : spin z-comp. of projectile
c               ip : transferred parity (=1; +, =2; -)
c              NDM : =1;(NN), =2;(ND), =3;(DD), =4;Full
c--------------------------------------------------------------------- 
      include 'dimn.fh'
      include 'form.fh'
c
      complex samp(nsrdm,njdm,njdm2,2,2,2,2)
      complex ampm(2,2,2,2,2,4)
      complex ovlpi,ovlpi2,ovsum
      complex ampa(nsrdm,2,2,2,2,6)
      complex ampi(0:nsrdm,2,2,2,2,ndmdp)
      complex ampl(nsrdm,2,2,2,2,ndmdp)
      dimension facrff(4),tmasx(2),pspn1(2),wgt(*)
c
      facrff(1)=1.0
      facrff(2)=2.0
      facrff(3)=1.0
c
      jtr=itrj-1
      jtr1w=2*jtr
      mxjp=jtr1w+1
      mxsi=pspn1(1)*2.0+1.01
      mxsf=pspn1(2)*2.0+1.01
c
      do 95 NDMtmp=1,4
      do 95 ip=1,2
        do 95 msi1=1,mxsi
          do 95 msf1=1,mxsf
            do 95 msi2=1,mxsi
              do 95 msf2=1,mxsf
                ampm(msf1,msi1,msf2,msi2,ip,NDMtmp)=(0.0,0.0)
   95 continue
      do 9000 mjr=1,mxjp
        do 180 ip=1,2
          do 180 ils=1,2
          do 180 msf=1,mxsf
            do 180 msi=1,mxsi
              ampi(0,msf,msi,ip,ils,1)=(0.0,0.0)
              ampi(0,msf,msi,ip,ils,2)=(0.0,0.0)
              do 180 n=1,nsrmax
                ampl(n,msf,msi,ip,ils,1)=(0.0,0.0)
                ampl(n,msf,msi,ip,ils,2)=(0.0,0.0)
                ampi(n,msf,msi,ip,ils,1)=(0.0,0.0)
                ampi(n,msf,msi,ip,ils,2)=(0.0,0.0)
                do 180 ktyp=1,6
                  ampa(n,msf,msi,ip,ils,ktyp)=(0.0,0.0)
  180   continue
c
c ampl(r,theta,m,msf,msi,ip,ils)
c
        if((ktamp.eq.0).or.(ktamp.eq.1).or.(ktamp.eq.7).or.
     &     (ktamp.eq.8)) then
          call acal(itrj,mjr,samp,wgt,ampa,mxsi,mxsf,nsrmax)
        end if
        if((ktamp.eq.0).or.(ktamp.eq.2).or.(ktamp.eq.8)) then
          call c1cal(itrj,mjr,samp,wgt,ampa,mxsi,mxsf,nsrmax)
        end if
        if((ktamp.eq.0).or.(ktamp.eq.3).or.(ktamp.eq.9)) then
          call c2cal(itrj,mjr,samp,wgt,ampa,mxsi,mxsf,nsrmax)
        end if
        if((ktamp.eq.0).or.(ktamp.eq.4).or.(ktamp.eq.7).or.
     &     (ktamp.eq.9)) then
          call ecal(itrj,mjr,samp,wgt,ampa,mxsi,mxsf,nsrmax)
        end if
        if((ktamp.eq.0).or.(ktamp.eq.5).or.(ktamp.eq.9)) then
          call fcal(itrj,mjr,samp,wgt,ampa,mxsi,mxsf,nsrmax)
        end if
        if((ktamp.eq.0).or.(ktamp.eq.6).or.(ktamp.eq.9)) then
          call bfcal(itrj,mjr,samp,wgt,ampa,mxsi,mxsf,nsrmax)
        end if
        if(ktamp.eq.7) then
          call BplusFcal(itrj,mjr,samp,wgt,ampa,mxsi,mxsf,nsrmax)
        end if
c---------------------------------------------------------------------
c ampl(r,theta,m,msf,msi,ip,ils)=ampa(...,a)+ampa(...,c1)+ampa(...,c2)
c                               +ampa(...,e)+ampa(...,f)+ampa(...,b-f)
c                                                   -->ktamp)=0
c                              =ampa(...,a)         -->ktamp=1
c                              =ampa(...,c1)        -->ktamp=2
c                              =ampa(...,c2)        -->ktamp=3
c                              =ampa(...,e)         -->ktamp=4
c                              =ampa(...,f)         -->ktamp=5
c                              =ampa(...,b-f)       -->ktamp=6
c                              =ampa(...,a)+ampa(...,e)
c                              +ampa(...,(b+f)/2)   -->ktamp=7
        do 985 ip=1,2
          do 983 ils=1,2
            do 980 msf=1,mxsf
              do 970 msi=1,mxsi
                do 950 n=1,nsrmax
                  ampi(n,msf,msi,ip,ils,1)
     1              =ampa(n,msf,msi,ip,ils,1)
     2              +ampa(n,msf,msi,ip,ils,2)
     3              +ampa(n,msf,msi,ip,ils,3)
     4              +ampa(n,msf,msi,ip,ils,4)
     5              +ampa(n,msf,msi,ip,ils,5)
     6              +ampa(n,msf,msi,ip,ils,6)
                  ampi(n,msf,msi,ip,ils,2) = fratio*
     3              (ampa(n,msf,msi,ip,ils,3)
     4              +ampa(n,msf,msi,ip,ils,4)
     5              +ampa(n,msf,msi,ip,ils,5)
     6              +ampa(n,msf,msi,ip,ils,6))
  950           continue
  970         continue
  980       continue
  983     continue
  985   continue
c
c     interporation of ampl
c
        do 994 ip=1,2
          do 993 ils=1,2
            do 992 msf=1,mxsf
              do 991 msi=1,mxsi
                do 990 n=1,nsrmax
                  rs=(Atg-1.0)/Atg*n*dsr
                  irs=rs/dsr
                  facint=(rs/dsr)-irs
                  ampl(n,msf,msi,ip,ils,1)
     1                    =facint*ampi(irs+1,msf,msi,ip,ils,1)
     2                    +(1.0-facint)*ampi(irs,msf,msi,ip,ils,1)
                  ampl(n,msf,msi,ip,ils,2)
     1                    =facint*ampi(irs+1,msf,msi,ip,ils,2)
     2                    +(1.0-facint)*ampi(irs,msf,msi,ip,ils,2)
  990           continue
  991         continue
  992       continue
  993     continue
  994   continue
c
        do 7801 NDM=1,NDMT
        if(NDM.eq.4) goto 7801
        if(NDM.eq.1) then
          Nampl1=1
          Nampl2=1
        else if(NDM.eq.2) then
          Nampl1=1
          Nampl2=2
        else if(NDM.eq.3) then
          Nampl1=2
          Nampl2=2
        endif
        do 7800 ip=1,2
          fm42cm=sqrt(sval)/tmasx(2)
          do 75 msi1=1,mxsi
            do 70 msf1=1,mxsf
              do 65 msi2=1,mxsi
                do 60 msf2=1,mxsf
                  ovsum=(0.0,0.0)
                  do 80 ils1=1,2
                    do 85 ils2=1,2
                      kls=2*(ils1-1)+ils2
                      ovlpi=(0.0,0.0)
                      do 561 nra=1,nsrmax
                        ovlpi2=(0.0,0.0)
                        do 560 nrb=1,nsrmax
                           ovlpi2=ovlpi2
     1                         +rffr(nra,nrb,ip,kls,itrj,NW,NDM)
     1                         *ampl(nrb,msf2,msi2,ip,ils2,Nampl1)
     1                         *wgt(nrb)
     1                         *facrff(NDM)
C===========================================================
  560                   continue
                        ovlpi=ovlpi
     1                       +conjg(ampl(nra,msf1,msi1,ip,ils1,Nampl2))
     1                       *ovlpi2*wgt(nra)
  561                 continue
                      ovsum=ovsum+ovlpi
C===========================================================
   85               continue
   80             continue
c--------------------------------------------------------------------
                  ampm(msf1,msi1,msf2,msi2,ip,NDM)
     1              =ampm(msf1,msi1,msf2,msi2,ip,NDM)
     &              +ovsum*fm42cm
C===========================================================
             if(NDM.eq.3) then
               ampm(msf1,msi1,msf2,msi2,ip,4)
     1          = ampm(msf1,msi1,msf2,msi2,ip,1)
     1          + ampm(msf1,msi1,msf2,msi2,ip,2)
     1          + ampm(msf1,msi1,msf2,msi2,ip,3)
             endif
C===========================================================
   60           continue
   65         continue
   70       continue
   75     continue
 7800   continue
 7801   continue
 9000 continue
c
      return
      end
