c----------------------------------------------------------------------
      subroutine   pgen2(ich,nrmax,dr,fkay1,sval,pmasx,tmasx,
     &  eta0,tcm,KTOUT_OPT)
c     generate the optical potentials
c---------------------------------------------------------------------
c     ktdrc = 0 ;nonrelativistic optical poential
c             1 ;dirac phenomenological potential
c             2 ;potntials are read from file 15
C             3 ;global relativistic optical potential for p; Hama et al.
C             4 ;global relativistic optical potential for n; Shen et al.
c  OUTPUT in modpot.fh
c     (vbcd,wbcd) = (1.0 - ucent/e)
c     (vsov,wsov) = -uso/e
c     bdrac       = sqrt((E+M+U_s-U_0)/(E+M)) 
c Modified by M.Ichimura 2016.4.25
c------- ---------------------------------------------------------------
      include 'dimn.fh'
      include 'base.fh'
      include 'modpot.fh'
      include 'potspc.fh'
c
      complex ueffS(NRDM+3),usoS(NRDM+3)
      complex bdrc0(NRDM+3)
      dimension pmasx(2),tmasx(2)
      character str*20
c
c Variables for glopt3
      real*8 usr(nrdm),usi(nrdm),uer(nrdm),uei(nrdm)
      real*8 Atin,Ztin,Zpin,Tpin,dxin
c
c Constants
      real*8 hc/197.326968d0/
      REAL*8 MN_AV/938.91937d0/
      REAL*8 al/137.036d0/
c
      zzz=zz1(ich)
      Tp_lab=(sval-(pmasx(ich)+tmasx(ich))**2)/(2.0*tmasx(ich))
      drho1=fkay1*dr
      rhobc1=rcd1(ich)*fkay1*Atg**0.3333333
      tautau=(Atg-2.0*tz1(ich))*(1.0-2.0*pz1(ich))*0.25/Atg
c
         do nr=1,nrmax+3
            bdrc(nr,ich) = 1.0
         end do
c*************************************************************
c  ktdrc=0  Non-relativistic optical potential
C           Parameters are read in input0
C*************************************************************
      if(ktdrc(ich).eq.0) then
C------------------------------------------------------------
         call  nrelopt(ich,Atg,nrmax,drho1,zzz,fkay1,
     &                     eta0,tcm,rhobc1,tautau)
c*************************************************************
c  ktdrc=1   Dirac phenomenological optical potential 
C            Parameters are read in input0
c****************************************************************
      else if(ktdrc(ich).eq.1) then
c---------------------------------------------------------------
         call drcopt(ICH,nrmax,fkay1,Atg,zzz,rhobc1,drho1)
c*************************************************************
c  ktdrc=2  External optical potential read from file 15
c*************************************************************
      else if(ktdrc(ich).eq.2) then
C----------------------------------------------------------------
        read(15,*) nrr,drr
        if((nrr.ne.nrmax+3).or.(abs(drr-dr).ge.0.001)) then
          write(6,890) nrr,drr
          stop
        end if
        read(15,*) (vbcd1(nr,ich),wbcd1(nr,ich),nr=1,nrmax+3)
        read(15,*) nrr,drr
        if((nrr.ne.nrmax+3).or.(abs(drr-dr).ge.0.001)) then
          write(6,890) nrr,drr
          stop
        end if
        read(15,*) (vsov1(nr,ich),wsov(nr,ich),nr=1,nrmax+3)
  890   format('nrmax or dr does not match in optical otential read',
     1  '  nrr=',i4,'  drr=',f5.2,'  nrmax+3=',i4,'  dr=',f5.2)
c
      rho=drho1
      do 840 nr=1,nrmax+3
c
c  coulomb potential
c
         if(zzz.ge.1.0) then
            if(rho.le.rhobc1) then
               etabc=eta0/rhobc1
               rhobc2=rhobc1*rhobc1
               rho2=rho*rho
               ffcl=etabc*(3.0-rho2/rhobc2)
            else
               ffcl=2.0*eta0/rho
            end if
         else
            ffcl=0.0
         end if
c
C  In case of non-relativistic calc., ffcl should be contained.
C          vbcd1(nr,ich) = 1.0 - count*(vbcd1(nr,ich)/tcm + ffcl)
c
          vbcd1(nr,ich) = 1.0 - vbcd1(nr,ich)/tcm
          wbcd1(nr,ich) =     - wbcd1(nr,ich)/tcm
          if (pspn1(ich).gt.0.1) then
            vsov1(nr,ich)=-vsov1(nr,ich)/tcm/pspn1(ich)
            wsov(nr,ich) = -wsov(nr,ich)/tcm/pspn1(ich)
          end if
          rho =rho+drho1
          rho2=rho*rho
  840   continue
c*************************************************************
c  ktdrc=3  Global optical potential for p-A; Hama et al.
c*************************************************************
      else if(ktdrc(ich).eq.3) then
c-------------------------------------------------------------
         Atin = Atg
         Ztin = tz1(ich)
         Zpin = pz1(ich)
         Tpin = Tp_lab
         dxin = dr
         ifit = ktglb(ich)
         call glopt3(nrmax,ifit,Atin,Ztin,Zpin,Tpin,dxin,
     &                  usr,usi,uer,uei,bdrc0)
c
         do nr=1,nrmax+3
            vbcd1(nr,ich)=1.0-uer(nr+1)/tcm
            wbcd1(nr,ich)=   -uei(nr+1)/tcm
            vsov1(nr,ich)=   -2.0d0*usr(nr+1)/tcm
            wsov(nr,ich) =   -2.0d0*usi(nr+1)/tcm
            bdrc(nr,ich) = sqrt(bdrc0(nr+1))
         end do
c*****************************************************************
c  ktdrc=4  global optical potential for n-A ; Shen et al.
c*****************************************************************
      else if(ktdrc(ich).eq.4) then 
C----------------------------------------------------------------
        call glopt2(nrmax,Atg,tz1(ich),Tp_lab,fkay1,drho1,
     &            ueffS,usoS,bdrc0)
c
        do nr=1,nrmax+3
           vsov1(nr,ich)=   - real(usoS(nr))
           wsov(nr,ich) =   -aimag(usoS(nr))
           vbcd1(nr,ich)=1.0- real(ueffS(nr))
           wbcd1(nr,ich)=   -aimag(ueffS(nr))
           bdrc(nr,ich) = sqrt(bdrc0(nr))
        end do
c--------------------------------------------------------------------
      end if
c------------------------------------------------------------------
c     Output Optical Potentials
c------------------------------------------------------------------
      if(KTOUT_OPT.eq.1) then
         if(ich.eq.1) str=' Incident Channel'
         if(ich.eq.2) str=' Exit Channel'
         write(6,4020) str
         write(6,4025) (((1.-vbcd1(nr,ich))*tcm), nr=1,nrmax+3)
         write(6,4026) ((-wbcd1(nr,ich)*tcm), nr=1,nrmax+3)
         write(6,4030) ((-vsov1(nr,ich)*tcm), nr=1,nrmax+3)
         write(6,4035) ((-wsov(nr,ich)*tcm), nr=1,nrmax+3)
      end if
 4020 format(//'Optical Potentials of',a20)
 4025 format(/'real part :central'/(1x,5e15.5))
 4026 format(/'imaginary part :central'/(1x,5e15.5))
 4030 format(/'spin orbit real '/(1x,5e15.5))
 4035 format(/'spin orbit imag wsov'/(1x,5e15.5))
c
      return
      end
