c ---------------------------------------------------------------------
      subroutine sp0cp(n,x,y,b,c,d)
c---------------------------------------------------------------------
c  Prepare the spline parameters for the complex function y(x)
c  Originally coded by Ulich Goetz, Latest update by M.I. 2013.8.28
c----------------------------------------------------------------------
c  INPUT from argument
c    n   : number of given points
c    x(n): table of the data point coordinates,x_i (i=1...n)
c    y(n): table of the complex function values y(x_i)
C  OUTPUT to argument
c    b(n): table of the spline parameters for the 1st order at x_i
c    c(n): table of the spline parameters for the 2nd order at x_i
c    d(n): table of the spline parameters for the 3rd order at x_i
c ---------------------------------------------------------------------
      implicit none
      integer n
      real x(n)
      complex y(n),b(n),c(n),d(n),t
      integer nm1,ib,i
c
      nm1=n-1
      if(n.lt.2)return
      if(n.lt.3)go to 50
      d(1)=x(2)-x(1)
      c(2)=(y(2)-y(1))/d(1)
      do 10 i=2,nm1
        d(i)=x(i+1)-x(i)
        b(i)=2.*(d(i-1)+d(i))
        c(i+1)=(y(i+1)-y(i))/d(i)
        c(i)=c(i+1)-c(i)
10    continue
      b(1)=-d(1)
      b(n)=-d(n-1)
      c(1)=(0.,0.)
      c(n)=(0.,0.)
      do 20 i=2,n
        t=d(i-1)/b(i-1)
        b(i)=b(i)-t*d(i-1)
        c(i)=c(i)-t*c(i-1)
20    continue
      c(n)=c(n)/b(n)
      do 30 ib=1,nm1
        i=n-ib
        c(i)=(c(i)-d(i)*c(i+1))/b(i)
30    continue
      b(n)=(y(n)-y(nm1))/d(nm1)+d(nm1)*(c(nm1)+2.*c(n))
      do 40 i=1,nm1
        b(i)=(y(i+1)-y(i))/d(i) - d(i)*(c(i+1)+2.*c(i))
        d(i)=(c(i+1)-c(i))/d(i)
        c(i)=3.*c(i)
40    continue
      c(n)=3.*c(n)
      d(n)=d(n-1)
      return
50    b(i)=(y(2)-y(1))/(x(2)-x(1))
      c(1)=(0.,0.)
      d(1)=(0.,0.)
      b(2)=b(1)
      c(2)=(0.,0.)
      d(2)=(0.,0.)
      return
      end
