c----------------------------------------------------------------------
      SUBROUTINE WRESP(qintd,fratio,omegd,NDMMAX,nwmax,KTRPA,
     &                 respT,respL)
C      OUTPUT RS,RT,RL,RV (TOTAL/FOR EACH ND-MODE)
c----------------------------------------------------------------------
C  INPUT
c     KTRPA   : Type of the correlation
c     qintd   : table of the intrinsic transferred momentum q_int
c     nwmax   : number of transferred energies
c     omegd   : table of omega_int (intrinsic transferred energy)
c     rps(w)     : spin scalar response function with fixed q
c     rpv(w,NDM) : trace of spin-vector response function with fixed q and NDM
c     rpl(w,NDM) : spin longitudinal response function with fixed q,NDM
c     NDMMAX  : N-D coupling channel indication
c       NDM = 1 : NN-channel, = 2 : ND-channel, = 3 : DD-channel
c     fratio  : f_piND/f_piNN
c----------------------------------------------------------------------
      include 'dimn.fh'
      include 'rsrtrl.fh'
      real*4 omegd(*),qintd(*)
      real*4 fr(3),respT(nwdm), respL(nwdm),respV(nwdm)
C===================================================================
C Full RV, RL and RT
C===================================================================
      fr(1)=1.0
      fr(2)=2*fratio
      fr(3)=fratio**2
c
         do nw=1,nwmax
            respV(nw) =0.0
            respT(nw)  =0.0
            respL(nw)  =0.0
         end do
      Do nw=1,nwmax 
         Do NDM=1,NDMMAX         
            respV(nw) = respV(nw) + fr(NDM)*rpv(nw,NDM)
            respL(nw) = respL(nw) + fr(NDM)*rpl(nw,NDM)
         End do
         respT(nw) = (respV(nw)-respL(nw))/2.0
      end do
c======================================================================
      write(6,5000)
 5000 format(
     &/'==========================================================='
     &/'RESPONSE FUNCTIONS RS, RT, RL, RV'
     &/'-----------------------------------------------------------')
      if(KTRPA.eq.0) write(6,*) '  Uncorrelated'
      if(KTRPA.eq.1) write(6,*) '  TDA'
      if(KTRPA.eq.2) write(6,*) '  RPA'
      if(KTRPA.eq.3) write(6,*) '  RPA for N TDA for D'
C
C    OUTPUT RS, RT, RL AND RV
            write(6,2004) 
            do nw=1,nwmax
               write(6,2100) omegd(nw),qintd(nw),
     1         rps(nw),respT(nw),respL(nw),respV(nw)
            end do
            write(*,*)
C   
 2100 format(5x,f6.2,5x,f6.3,4x,4e13.5)
 2004 format(5x,
     1 'omega(MeV) q_int(1/fm)     RS           RT          RL',
     2 '          RV')
C
      return
      end
