C---------------------------------------------------------------------
      SUBROUTINE WRITE0(EPSJ,Vtautau,knmin,knmax,prmass,ejmass,tgmass,
     & EFL,WSHIFT,thetlmn,dthetl,omglmn,domegl,lparmn,lparmx,KTLTR,obex)
C      WRITE INPUT DATA OF CRDW
C---------------------------------------------------------------------
      INCLUDE 'dimn.fh'
c  common blocks
      INCLUDE 'fund1.fh'
      INCLUDE 'fund2.fh'
      include 'base.fh'
      INCLUDE 'numrun.fh'
      INCLUDE 'opep.fh'
      include 'gprtrm.fh'
      include 'hprtrm.fh'
      INCLUDE 'opta1.fh'
      INCLUDE 'opta2.fh'
      INCLUDE 'clom.fh'
      INCLUDE 'orbt.fh'
      INCLUDE 'cntl.fh'
      include 'theta.fh'
      include 'drcpot.fh'
      include 'stdpot.fh'
      include 'coul.fh'
      include 'potspc.fh'
c
      character str*60
C==============================================================
c   Date and run number
c--------------------------------------------------------------
      write(6,1050) (numrun(I),I=1,4),ititle
 1050 format(i2,'-',i2,'-',i4,'-',i2/1x,25a4)
C=============================================================
      write(6,1100)
 1100 FORMAT(
     & '============================================================'
     &/'RESPONSE FUNCTION CALCULATION AND OUTPUT OPTIONS'
     &/'------------------------------------------------------------'
     &)
c==============================================================
c   RPA calculation options
c--------------------------------------------------------------
      WRITE(6,1200)
 1200 format(' CALCULATION OPTIONS')
      IF(KTDW.EQ.2) write(*,*) ' KTDW  =',KTDW,
     & '  Only response function calculation'

      IF(KTRPA.EQ.0) str='  UNPERTURBED CONTINUUM SHELL MODEL'
      IF(KTRPA.EQ.1) str='  Tamm-Dancoff Approximation'
      IF(KTRPA.EQ.2) str='  CONTINUUM RPA(RING APPROXIMATION)'
      IF(KTRPA.EQ.3) str='  RPA for p-h but TDA for Delta-h'
      write(*,*) ' KTRPA =',KTRPA,str
c
      If(KTRPA.NE.0) then
         IF(KTND.EQ.0)  str= '  Nucleon Space only'
         IF(KTND.EQ.1)  str= '  Nucleon+Delta Space'
         write(*,*) ' KTND  =',KTND,str
         IF(KTVEFF.EQ.0)  str= '  LM only'
         IF(KTVEFF.EQ.1)  str= '  LM + OBEP'
         write(*,*) ' KTVEFF=',KTVEFF,str
      END IF
c
      IF(KTRQCV.EQ.1) str='  Convergence check by RS and RV '
      IF(KTRQCV.EQ.2) str='  Convergence chech by RS'
      IF(KTRQCV.EQ.3) str='  Convergence check by RV'
      if(KTRQCV.ne.0) then
         write(*,*) ' KTRQCV =',KTRQCV,str
         WRITE(6,8000) EPSJ
      end if
 8000 FORMAT(14x,'CONVERGENCE CRITERION  EPSJ  = ',f7.5)
      IF(KTHSPWD.EQ.0)  str= '  No spreading widths of holes'
      IF(KTHSPWD.EQ.1)  str= '  With spreading widths of holes'
         write(*,*) ' KTHSPWD=',KTHSPWD,str
c===============================================================
C   Output options
c----------------------------------------------------------------
      IF((KTOUT_VEF.GE.1).OR.(KTOUT_BDW.GE.1).OR.(KTOUT_RQ.GE.1))
     & WRITE(6,1232)
 1232 format(/ ' OUTPUT OPTIONS')
      IF(KTOUT_RQ.NE.0) then
       IF(KTOUT_RQ.EQ.1) str='  Output R(q,w)'
       IF(KTOUT_RQ.EQ.2) str='  Output R(q,w) and also R^{N/D,N/D}(q,w)'
         write(*,*) ' KTOUT_RQ =',KTOUT_RQ,str
      end if
      IF(KTOUT_VEF.GE.1) write(*,*) ' KTOUT_VEF=',KTOUT_VEF,
     & '  Output Effective Interaction in r-Space'
      IF(KTOUT_BDW.GE.1) write(*,*) ' KTOUT_BDW=',KTOUT_BDW,
     &  '  Output Bound State Wave Func. in step of KTOUT_BDW'
C===================================================================
c   Basic Data
c-------------------------------------------------------------------
c   Mass, Charge and Spin of the reaction particles
c-------------------------------------------------------------------
      write(6,1000) Atg,pz1(1),tz1(1),pz1(2), 
     &              prmass,tgmass,ejmass
 1000 format(
     & '==========================================================='
     &/'Masses, charges, incident energy and scattering angles '
     &/'-----------------------------------------------------------'
     &/'  Target Mass Number: Atg =',f5.1
     &/'  Projectile Charge : Zpr =',f5.1
     &/'  Target     Charge : Ztg =',f5.1
     &/'  Ejejectile Charge : Zej =',f5.1
     &/'  Projectile Mass   : prmass=',f10.2,' MeV'
     &/'  Target     Mass   : tgmass=',f10.2,' MeV'
     &/'  Ejejectile Mass   : ejmass=',f10.2,' MeV')
C----------------------------------------------------------------------
c   Incident kinetic energy, Scattering angles, and Transferred energy
c----------------------------------------------------------------------
      write(6,1010) elabi
 1010 format(/'  Incident energy (lab): elabi=',f8.3,'(MeV)')
      WRITE(6,1020) nanmax,thetlmn,dthetl
 1020 FORMAT(/'  Scattering Angles (lab)'/1x,
     &'   nanmax =',I3,2x,'thetlmn =',f7.3,2x,'dthetl = ',f7.3)
      WRITE(6,1030) nwmax,omglmn,domegl
 1030 FORMAT(
     & '============================================================'
     &/'TRANSFERED QUANTITIES'
     &/'------------------------------------------------------------'
     &/'  Transferred energy (lab)'/1x,
     &'   nwmax  =',I3,2x,'omglmn  =',f7.3,2x,'domegl = ',f7.3)
      IF(ABS(wshift).GT.0.001) write(*,*) '   WSHIFT =',WSHIFT
c---------------------------------------------------------------------
c   Transferred charge, angular momentum and parity
c---------------------------------------------------------------------
      WRITE(6,2000) ITRZ,ITRJMN,ITRJMX
 2000 FORMAT(
     &/'  Transferred Charge  ITRZ = ',I2,
     &/'  Transferred Total Angular Momentum: TRJMIN =',I2,
     & '  TRJMAX =',I2)
      if(knmin.eq.2)     write(6,*) 
     &        ' Excited State Parity : unnatural '
      if(knmax.eq.1)     write(6,*) 
     &        ' Excited State Parity : natural '
      if(knmin.ne.knmax) write(6,*) 
     &        ' Excited State Parity : Natural and Unnatural'
      if(KTLTR.eq.1) write(6,*) 
     & ' KTLTR=1: Only the lowest Ltr for the given Jtr'
C=====================================================================
c   Core and single particle data
c---------------------------------------------------------------------
      WRITE(6,3000)
 3000 FORMAT(
     &/'==============================================================='
     &/'Core and Single Particle Data'
     &/'---------------------------------------------------------------'
     &)
C
      IF(KTND.EQ.0) THEN
      WRITE(6,3100)
 3100 FORMAT(
     & ' ICH =',5X,'1 ', 7X,'2 ', 8X,'3',8X,'4',
     &/'      ',4X,'n-h',6X,'p-h',8X,'n',8X,'p')
C
      WRITE(6,3200) 
     &              (PMAS(I),I=1,4),(TMAS(I),I=1,4),
     &              (PZ(I),I=1,4),(TZ(I),I=1,4),
     &              (PSPN(I),I=1,4),
     &              (VD(I),I=1,4),
     &              (RRD(I),I=1,4),
     &              (ARD(I),I=1,4),
     &              (RCD(I),I=1,4),
C
     &              (VSOD(I),I=1,4),
     &              (RSOD(I),I=1,4),
     &              (ASOD(I),I=1,4),
C
     &              (WD(I),I=1,4),
     &              (WV0(I),I=1,4),(WS0(I),I=1,4),
     &              (RID(I),I=1,4),(AID(I),I=1,4),
     &              (RVD2(I),I=1,4),(AVD2(I),I=1,4),
C
     &              (BDIFD(I),I=1,4),
     &              (REFFD(I),I=1,4),(AEFFD(I),I=1,4),
     &              (alphsw(I),I=1,4),
     &              (eps0sw(I),I=1,4),
     &              (eps1sw(I),I=1,4),
     &              (BEFM(I),I=1,4)
 3200 FORMAT( 
     &         'PMASS=',4F9.3,/'TMASS=',4F9.3,
     &        /'  PZ =',4F9.3,/'  TZ =',4F9.3,
     &        /'PSPN =',4F9.3,
     &       //'  VD =',4F9.3,
     &        /'  RR =',4F9.3,/'  AR =',4F9.3,
     &        /' RCD =',4F9.3,
     &       //' VSO =',4F9.3,
     &        /' RSO =',4F9.3,/' ASO =',4F9.3,
     &       //'  WD =',4F9.3,
     &        /' WV0 =',4F9.3,/' WS0 =',4F9.3,
     &        /'  RI =',4F9.3,/'  AI =',4F9.3,
     &        /' RV2 =',4F9.3,/' AV2 =',4F9.3,
     &       //'BDIF =',4F9.3,
     &        /'REFF =',4F9.3,/'AEFF =',4F9.3
     &       //'alphsw=',4F9.3,
     &        /'eps0sw=',4F9.3,
     &        /'eps1sw=',4F9.3,
     &        /'BEFM  =',4F9.3
     &       )
      end if
C--------------------------------------------------------------------
      IF(KTND.EQ.1) THEN
      WRITE(6,3300)
 3300 FORMAT(
     & ' ICH =',5X,'1 ',7X,'2 ',8X,'3',8X,'4',7X,' 5',8X,'6',
     &          8X,'7',8X,'8'
     &/'      ',4X,'n-h',6X,'p-h',8X,'n',8X,'p',8X,'D-',7X,'D0',
     &          7X,'D+',6X,'D++')
C
      WRITE(6,3400) 
     &              (PMAS(I),I=1,8),(TMAS(I),I=1,8),
     &              (PZ(I),I=1,8),(TZ(I),I=1,8),
     &              (PSPN(I),I=1,8),
C
     &              (VD(I),I=1,8),
     &              (RRD(I),I=1,8),
     &              (ARD(I),I=1,8),
     &              (RCD(I),I=1,8),
     &              (VSOD(I),I=1,8),
     &              (RSOD(I),I=1,8),
     &              (ASOD(I),I=1,8),
C
     &              (WD(I),I=1,8),
     &              (WV0(I),I=1,8),
     &              (WS0(I),I=1,8),
     &              (RID(I),I=1,8),
     &              (AID(I),I=1,8),
     &              (RVD2(I),I=1,8),
     &              (AVD2(I),I=1,8),
C
     &              (BDIFD(I),I=1,4),
     &              (REFFD(I),I=1,4),
     &              (AEFFD(I),I=1,4),
     &              (alphsw(I),I=1,4),
     &              (eps0sw(I),I=1,4),
     &              (eps1sw(I),I=1,4),
     &              (BEFM(I),I=1,4)
 3400 FORMAT( 
     &         'PMASS=',8F9.3,/'TMASS=',8F9.3,
     &        /'  PZ =',8F9.3,/'  TZ =',8F9.3,
     &        /'PSPN =',8F9.3,
     &       //'  VD =',8F9.3,
     &        /'  RR =',8F9.3,/'  AR =',8F9.3,
     &        /' RCD =',8F9.3,
     &       //' VSO =',8F9.3,
     &        /' RSO =',8F9.3,/' ASO =',8F9.3,
     &       //'  WD =',8F9.3,
     &        /' WV0 =',8F9.3,/' WS0 =',8F9.3,
     &        /'  RI =',8F9.3,/'  AI =',8F9.3,
     &        /' RV2 =',8F9.3,/' AV2 =',8F9.3,
     &       //'BDIF =',4F9.3,
     &        /'REFF =',4F9.3,
     &        /'AEFF =',4F9.3
     &       //'alphsw=',4F9.3,
     &        /'eps0sw=',4F9.3,
     &        /'eps1sw=',4F9.3,
     &        /'BEFM  =',4F9.3
     &       )
      end if
c===================================================================
c   (p-h)/(Delta-h) pair specification
C--------------------------------------------------------------------
      WRITE(6,4000)
 4000 FORMAT(/'================================================='
     &       /'(p-h)/(Delta-h) pair specification '
     &       /'-------------------------------------------------'
     &       /7X,'IPSD1     IPSD2     FBCK')
C
      I=1
      DO K=1,2
        NMAX=NPAIRX(K)
        DO N=1,NMAX
          WRITE(6,4100) I,IPSD1(N,K),IPSD2(N,K),FBCK(N,K)
          I=I+1
        END DO
      END DO
 4100 FORMAT(I2,')  ',I5,'  -  ',I5,4X,F7.2,3X,F7.2)
C=====================================================================
c   EFFECTIVE INTERACTION PARAMETERS
c---------------------------------------------------------------------
      if(KTRPA.ne.0) then 
         WRITE(6,5000)
 5000 FORMAT(
     &/'============================================================'
     &/'EFFECTIVE INTERACTION PARAMETERS'
     &/'------------------------------------------------------------'
     &)
c
      write(6,5010) Vtautau
 5010 format('Spin scalar interaction'/'  Vtautau(MeVfm^3) =',f10.5)
c
      write(6,5020)
 5020 format(/'Spin vector interaction')
        WRITE(6,5030) FACBS,FRATIO,CRHOO,OBEX,EPION,ERHOO,
     &                ctpi(1),nctpi(1),ctpi(2),nctpi(2),
     &                ctrh(1),nctrh(1),ctrh(2),nctrh(2),
     &                GPR(1,1),GPR(1,2),GPR(2,1),GPR(2,2),
     &                ctgpr,nctgpr,
     &                hpr(1,1),hpr(1,2),hpr(2,1),hpr(2,2),
     &                cthpr,ncthpr
 5030 FORMAT('  F*F/4*PI    =',F10.4,'  FRATIO      =',F10.4,
     &      /'  CRHOO       =',F10.4,'  OBEX        =',F10.4,
     &      /'  MPION (MEV) =',F10.4,'  MRHOO (MEV) =',F10.4,
     &      /'  LAMPIN(MEV) =',F10.4,'  NPIN        =',I2,
     &      /'  LAMPID(MEV) =',F10.4,'  NPID        =',I2,
     &      /'  LAMRHN(MEV) =',F10.4,'  NRHN        =',I2,
     &      /'  LAMRHD(MEV) =',F10.4,'  NRHD        =',I2,
     &      /'  GPR(1,1)    =',F10.4,'  GPR(1,2)    =',F10.4,
     &      /'  GPR(2,1)    =',F10.4,'  GPR(2,2)    =',F10.4,
     &      /'  LAMGPRM(MEV)=',F10.4,'  NGPRM       =',I2,
     &      /'  HPR(1,1)    =',F10.4,'  HPR(1,2)    =',F10.4,
     &      /'  HPR(2,1)    =',F10.4,'  HPR(2,2)    =',F10.4,
     &      /'  LAMHPRM(MEV)=',F10.4,'  NHPRM       =',I2
     &      )
      end if
C====================================================================
c   INTEGRATION DATA
c--------------------------------------------------------------------
      WRITE(6,6000)NRMAX,DR,RMAX,NSRMAX,DSR,NKMAX,TKDMX
C
 6000 FORMAT(
     &/'============================================================='
     &/'INTEGRATION DATA'
     &/'-------------------------------------------------------------'
     & /' NRMAX =',I4,'  DR =',F6.3,'  RMAX =',F8.3
     & /' NSRMAX=',I4,'  DSR=',F6.3
     & /' NKMAX =',I4,'  TKDMX =',F6.3,' 1/FM')
C===================================================================
      IF(KTDW.EQ.2) GOTO  9000      
C====================================================================
C   DWIA INPUT DATA
C--------------------------------------------------------------------
      write(6,7000)
 7000 FORMAT(
     &/'============================================================='
     &/' DWIA INPUT DATA'
     &/'-------------------------------------------------------------'
     & )
c
      IF(KTDW.EQ.0)  
     & write(*,*) 'DWIA/PWIA      :  PWIA(KTDW=',KTDW,')'
      IF(KTDW.EQ.1)
     & write(*,*) 'DWIA/PWIA      :  DWIA(KTDW=',KTDW,')'
c
      IF(KTTNN.EQ.0)
     & write(*,*) 'NN t-MATRIX    :  Optimal fact.(KTTNN =',KTTNN,')'
      IF(KTTNN.EQ.1) then
         write(*,*) 'NN t-MATRIX    :  Franey-Love(KTTNN =',KTTNN,')'
         IF(EFL.gt.0.01) write(6,7015) EFL 
         IF(EFL.lt.0.01) write(6,7015) ELABI 
      END IF
 7015 FORMAT('   E_FL =',f8.2)
C
      IF(KTAMP.EQ.0) 
     & write(*,*) 'NN AMP INCLUDED:  FULL(KTAMP =',KTAMP,')'
      IF(KTAMP.EQ.1)
     & write(*,*) 'NN AMP INCLUDED:  A(KTAMP =',KTAMP,')'
      IF(KTAMP.EQ.2)
     & write(*,*) 'NN AMP INCLUDED:  C1(KTAMP =',KTAMP,')'
      IF(KTAMP.EQ.3)
     & write(*,*) 'NN AMP INCLUDED:  C2(KTAMP =',KTAMP,')'
      IF(KTAMP.EQ.4)
     & write(*,*) 'NN AMP INCLUDED:  E(KTAMP =',KTAMP,')'
      IF(KTAMP.EQ.5) 
     & write(*,*) 'NN AMP INCLUDED:  F(KTAMP =',KTAMP,')'
      IF(KTAMP.EQ.6) 
     & write(*,*) 'NN AMP INCLUDED:  B-F(KTAMP =',KTAMP,')'
      IF(KTAMP.EQ.7) 
     & write(*,*) 'NN AMP INCLUDED:  A+Cent+Tensor (KTAMP =',KTAMP,')'
      IF(KTAMP.EQ.8) 
     & write(*,*) 'NN AMP INCLUDED:  A+C1(KTAMP =',KTAMP,')'
      IF(KTAMP.EQ.9)  
     & write(*,*) 'NN AMP INCLUDED:  E+F+(B-F)+C2(KTAMP =',KTAMP,')'
      write(6,7030) lparmn,lparmx
 7030 format(/' Partial Waves;  lpar_min=',i3,'  lpar_max=',i3)
c================================================================
c   DWIA output options
c----------------------------------------------------------------
       WRITE(6,1230)
 1230 format(/ ' DWIA OUTPUT OPTIONS')
      IF(KTOUT_XS.EQ.1) write(*,*) ' KTOUT_XS =',KTOUT_XS,
     &     '  Individual Contributions from NN,ND and DD Process'
      IF(KTOUT_XS.EQ.2) write(*,*) ' KTOUT_XS =',KTOUT_XS, 
     &     '  Contributions from each Jtr and Parity'
C
      IF(KTOUT_XSJ.EQ.1) write(*,*) ' KTOUT_XSJ =',KTOUT_XSJ,
     &     '  Output x-sec etc. for each Jtr and parity'
C
      IF(KTOUT_OPT.EQ.1)write(*,*) ' KTOUT_OPT =',KTOUT_OPT,
     &     '  Output Incident and Exit Channel Optical Potetials'
C
      IF(KTOUT_DW.NE.0) write(*,*) ' KTOUT_DW =',KTOUT_DW,
     &     '  Output Incident and Exit Channel Distorted Waves'
      IF(KTOUT_NNA.NE.0) write(*,*)     ' KTOUT_NNA =',KTOUT_NNA,
     &     '  Output square of NN amplitudes'
      IF(KTOUT_LTRATIO.NE.0) write(*,*) ' KTOUT_LTRATIO =',KTOUT_NNA,
     &     '  Output L/T ratio '
C====================================================================
C   OPTICAL POTENTIAL
C--------------------------------------------------------------------       
      if(KTDW.eq.1) then
         write(*,*)
         write(*,*) 'OPTICAL POTENTIAL'
      do i=1,2
         if(i.eq.1) write(6,*) ' <Incident channel>'
         if(i.eq.2) write(6,*) ' <Exit channel>'
            if(ktdrc(i).eq.0) then
               write(6,7080) ktdrc(i),
     &           vd1(i),wd1(i),vsod1(i),wsod(i),visd(i),wisd(i),
     &           rrd1(i),rid1(i),rsord(i),rsoid(i),risrd(i),risid(i),
     &           ard1(i),aid1(i),asord(i),asoid(i),aisrd(i),aisid(i),
     &           rcd1(i),rgd(i),agd(i),csdgd(i)
            else if(ktdrc(i).eq.1) then
               write(6,7090) ktdrc(i),vsd(i),wsd(i),vvd(i),wvd(i),
     &           rsd(i),asd(i),rvd(i),avd(i),rsid(i),asid(i),
     &           rvid(i),avid(i),rcd1(i)
            else if(ktdrc(i).eq.2) then
               write(6,7100) ktdrc(i)
            else if(ktdrc(i).eq.3) then
               write(6,7070) ktdrc(i)
               if(ktglb(i).eq.1) then 
                 write(*,*) 
     &       '   CA40-PB208 (P,P) 65-1040 MEV  FIT.1  ktglb=', ktglb(i)
               else if(ktglb(i).eq.2) then 
                 write(*,*) 
     &       '   CA40-PB208 (P,P) 65-1040 MEV  FIT.2  ktglb=', ktglb(i)
               else if(ktglb(i).eq.3) then 
                 write(*,*) 
     &       '   C12 (P,P)   29-1040 MEV   ktglb=',ktglb(i)
               else if(ktglb(i).eq.4) then 
                 write(*,*) 
     &       '   O16 (P,P)   23-1040 MEV   ktglb=',ktglb(i)
               else if(ktglb(i).eq.5) then 
                 write(*,*) 
     &       '   CA40 (P,P)  21-1040 MEV   ktglb=',ktglb(i)
               else if(ktglb(i).eq.6) then 
                 write(*,*) 
     &       '   ZR90 (P,P)  22-800  MEV   ktglb=',ktglb(i)
               else if(ktglb(i).eq.7) then 
                 write(*,*) 
     &       '   PB208 (P,P) 21-1040 MEV   ktglb=',ktglb(i)
               else if(ktglb(i).eq.8) then 
                 write(*,*) 
     &       '   C12-PB208 (P,P) 21-1040 MEV FIT.1  ktglb=',ktglb(i)
               else if(ktglb(i).eq.9) then 
                 write(*,*) 
     &       '   C12-PB208 (P,P) 21-1040 MEV FIT.2   ktglb=',ktglb(i)
               else if(ktglb(i).eq.10) then 
                 write(*,*) 
     &       '   C12-PB208 (P,P) 21-1040 MEV FIT.3   ktglb=',ktglb(i)
               else if(ktglb(i).eq.11) then 
                 write(*,*) 
     &       '   4HE-PB208 (P,P) 21-1040 MEV (UNDEMOCRATIC, TC) ktglb=',
     &          ktglb(i)
               else if(ktglb(i).eq.12) then 
                 write(*,*) 
     &       '   4HE-PB208 (P,P) 21-1040 MEV (DEMOCRATIC, SH)  ktglb=',
     &           ktglb(i)
               else if(ktglb(i).eq.13) then 
                 write(*,*) 
     &     '   4HE (P,P)   156-1728 MEV   ktglb=', ktglb(i)
               end if
            else if(ktdrc(i).eq.4) then
               write(6,7060) ktdrc(i)
            end if
 7060       format('  Global relativistic opt. pot.; Shen   ktdrc=',i2)
 7070       format('  Global relativistic opt. pot.; Cooper   ktdrc='
     &             ,i2)
 7080       format('  Non-relativistic optical pot.  ktdrc=',I2/
     &           '   v=',f8.3,2x,'     w=',f8.3,2x,
     &           '   vso=',f8.3,2x,'   wso=',f8.3/
     &           '   vis=',f8.3,2x,'   wis=',f8.3/
     &           '    r0=',f8.3,2x,'    ri=',f8.3,2x,
     &           '  rsor=',f8.3,2x,'  rsoi=',f8.3/
     &           '  risr=',f8.3,2x,'  risi=',f8.3/
     &           '    ar=',f8.3,2x,'    ai=',f8.3,2x,
     &           '  asor=',f8.3,2x,'  asoi=',f8.3/
     &           '  aisr=',f8.3,2x,'  aisi=',f8.3/
     &           '    rc=',f8.3,2x,'    rg=',f8.3,2x,
     &           '    ag=',f8.3,2x,'  csdg=',f8.3,/)
 7090       format('  Dirac phenomenological optical pot.  ktdrc=',I2/
     &           '    vs=',f8.3,2x,'    ws=',f8.3,2x,
     &           '    vv=',f8.3,2x,'    wv=',f8.3/,
     &           '    rs=',f8.3,2x,'    as=',f8.3,2x,
     &           '    rv=',f8.3,2x,'    av=',f8.3/,
     &           '   rsi=',f8.3,2x,'   asi=',f8.3,2x,
     &           '   rvi=',f8.3,2x,'   avi=',f8.3/,
     &           '    rc=',f8.3/)
 7100       format('  Optical pot. is read from unit 15  ktdrc=',I2)
      end do
      end if
C
 9000 RETURN
      END
