c----------------------------------------------------------
      subroutine wxpol(nan,nwmax,thetld,omegld,NDMT,
     &                 KTOUT_XS,KTOUT_LTRATIO)
c  Output Xsec,Pol,Ay,Dij,ratio for given angle,omega,ND-modes
c-------------------------------------------------------------------
c  INPUT
C     nan
c     nwmax
c     KTOUT_XS
C     NDMT
C     sumx(nandm,nwdm,4),sumxl(nandm,nwdm,4),
C     pols(nandm,nwdm,4),asyms(nandm,nwdm,4),
C     DSS(nandm,nwdm,4),DSL(nandm,nwdm,4),DNN(nandm,nwdm,4),
C     DLS(nandm,nwdm,4),DLL(nandm,nwdm,4),
C     Dqq(nandm,nwdm,4),Dqp(nandm,nwdm,4),
C     Dpq(nandm,nwdm,4),Dpp(nandm,nwdm,4),
C     xid0l(nandm,nwdm,4),xidnl(nandm,nwdm,4),
C     xidql(nandm,nwdm,4),xidpl(nandm,nwdm,4),
C     ratlt(nandm,nwdm,4)
c--------------------------------------------------------------------
      include 'dimn.fh'
      include 'xsec.fh'
      real*4 thetld(*),omegld(*)
      character str*50
C-------------------------------------------------------------------
C         Output x-sec, P, A, Dij
C-------------------------------------------------------------------
      DO 6666 NDM=1,NDMT
      IF((KTOUT_XS.EQ.0).AND.(NDM.LT.NDMT)) GOTO 6666
      if(NDM.eq.1) str=': NN-NN verteces' 
      if(NDM.eq.2) str=': NN-ND verteces' 
      if(NDM.eq.3) str=': ND-ND verteces' 
      if(NDM.eq.4) str=': Full Contribution'
C
      write(6,1000) NDM,str
      write(6,1010) thetld(nan)
      write(6,1020) 
 1000 format(
     &/'==============================================================='
     &/'Cross sections and Spin Observables. NDM=',I1,a30
     &/'---------------------------------------------------------------'
     &)
 1010 format('theta(lab) =',f6.2,'(deg)')
 1020 format(
     &/'Xsec, P and A'/' omeg(lab)  ',
     &'(mb/mev*sr)(cm) (mb/mev*sr)(l)','    pol(%)      asym(%)')
c
      do nw=1,nwmax
         write(6,2200) omegld(nw),
     &        sumx(nan,nw,NDM),sumxl(nan,nw,NDM),
     &        pols(nan,nw,NDM),asyms(nan,nw,NDM)
      end do
 2200 format(1x,f6.2,3x,2e15.5,1x,2f12.4)
C
      write(6,3000)
 3000 format(/'Dij (lab)'/' omeg(lab)  ',
     &'Dss(%)      Dsl(%)      Dnn(%)      Dls(%)      Dll(%)')
      do nw=1,nwmax
         write(6,2600) omegld(nw),
     &        DSS(nan,nw,NDM),DSL(nan,nw,NDM),DNN(nan,nw,NDM),
     &        DLS(nan,nw,NDM),DLL(nan,nw,NDM)
      end do
 2600 format(1x,f6.2,5f12.4)
C
      write(6,3200)
 3200 format(/'Dij(q)',/' omeg(lab)  ',
     &'Dqq(%)      Dqp(%)      Dnn(%)      Dpq(%)      Dpp(%)')
      do nw=1,nwmax
         write(6,2600)  omegld(nw),
     &        Dqq(nan,nw,NDM),Dqp(nan,nw,NDM),Dnn(nan,nw,NDM),
     &        Dpq(nan,nw,NDM),Dpp(nan,nw,NDM)
      end do
C
      write(6,3360) 
 3360 format(/'IDi(lab.).',/' omeg(lab)  ',
     &'  ID0         IDn         IDq         IDp')
      do nw=1,nwmax
         write(6,2750) omegld(nw),
     &        xid0l(nan,nw,NDM),xidnl(nan,nw,NDM),
     &        xidql(nan,nw,NDM),xidpl(nan,nw,NDM)
      end do
 2750 format(1x,f6.2,3x,4e12.4)
C
      IF(KTOUT_LTRATIO.EQ.1) THEN
         write(6,3400) 
 3400    format(/'ratio RL/RT',/' omeg(lab)    RL/RT')
         do nw=1,nwmax
            write(6,2770) omegld(nw),ratlt(nan,nw,NDM)
         end do
 2770    format(1x,f6.2,4x,f9.4)
      END IF
C
 6666 continue
      return
      end
